#pragma once

#include "types.h"



/* Region-related state information. */

class RegionState
{
public:
    unsigned long size;
    fileid_t fileid;
    offset_t filepos;

    explicit RegionState(unsigned long size=0, fileid_t fileid=0, offset_t filepos=0);

    void fill(fileid_t fileid, offset_t filepos);

    bool valid() { return size != 0; }
};



/* A memory region abstraction. */

class Region
{
public:
    offset_t start, end;

    /* Debugging information. */

    RegionState state;

    /* Methods. */

    explicit Region(offset_t start, offset_t end);

    virtual ~Region();

    offset_t size();

    int compare(Region *other);

    void fill(fileid_t fileid, offset_t filepos);

    void flush();

    /* Simulation methods. */

    char *read(offset_t offset=0);

    void write(const char *data, offset_t offset=0);
};

// vim: tabstop=4 expandtab shiftwidth=4
